/***************************************************************

  BayCom(R)        Packet-Radio fuer IBM PC

  OpenBayCom-Mailbox

  Routinen fuer Benutzeroberflaeche

  ----------------
  Window-Utilities
  ----------------


  Copyright (c)       Florian Radlherr
                      Taubenbergstr. 32
                      83627 Warngau

  Alle Rechte vorbehalten / All Rights Reserved

 ***************************************************************/

#include "baycom.h"

/*---------------------------------------------------------------------------*/

unsigned alt_taste(unsigned scan)
//**********************************************************************
//
//  wird mit dem Bioscode einer Taste aufgerufen
//
//**********************************************************************
{ static char tasttab[52]=
  { '1','2','3','4','5','6','7','8','9','0',0,0,0,0,0,0,
    'Q','W','E','R','T','Y','U','I','O','P',0,0,0,0,
    'A','S','D','F','G','H','J','K','L',0,0,0,0,0,
    'Z','X','C','V','B','N','M'
  };

  if(scan&255)
    return 0;
  else
    scan>>=8;

  if(scan<16)
    return 0;

  if((scan>=104)&&(scan<=113))       // Funktionstasten ALT-F1 .. ALT-F10
    scan-=104;
  if((scan>=120)&&(scan<=129))       // Tasten 1 .. 0
    scan-=120;

  if(scan<51)                   // Buchstaben-Code ?
    return tasttab[scan];
  else
    return 0;
}

/*---------------------------------------------------------------------------*/

unsigned f_taste(unsigned scan)
//**********************************************************************
//
//  wertet einen Scancode aus, und gibt zurueck, wenn es eine Funktions-
//  Taste war.
//
//    Returnwerte:
//    0      keine Funktionstaste
//    1 -10     F1 -       F10
//    11-20  SHIFT F1 - SHIFT F10
//    21-30  CTRL  F1 - CTRL  F10
//    31-40  ALT   F1 - ALT   F10
//
//**********************************************************************
{ if(scan&255)
    return 0;
  else
    scan>>=8;

  if(scan<59)
    return 0;

  if(scan<69)
    return scan-58;
  if((scan>83)&&(scan<=113))
    return scan-73;
  return 0;
}
