/***************************************************************

  BayCom(R)        Packet-Radio fuer IBM PC

  OpenBayCom-Mailbox

  --------------------------------------------------
  Definitionen fuer internationale Meldungen der Box
  --------------------------------------------------


  Copyright (C)       Florian Radlherr
                      Taubenbergstr. 32
                      83627 Warngau

  Alle Rechte vorbehalten / All Rights Reserved

 ***************************************************************/

typedef enum
{ m_sendnotpossible,    // mbsend.cpp
  m_boardnotpossible,   // mbread.cpp, mbsend.cpp
  m_messagenotforward,
  m_forwardunknown,
  m_title,
  m_textinput,
  m_textsend,
  m_linesfor,
  m_stored,
  m_msgarrived,
  m_nomessagestored,
  m_bidexists,
  m_address,
  m_fwdunknown,
  m_isknown,
  m_isadjacent,       // obsolete
  m_noforwarding,
  m_syntaxpath,
  m_adrunknown,       // mbread.cpp, mbserver.cpp
  m_givenumber,
  m_erased,
  m_unerased,
  m_forwarded,
  m_syntaxforward,
  m_lifetimeset,
  m_syntaxlifetime,
  m_tr_ok,              // mbread.cpp
  m_tr_syntax,          // mbread.cpp
  m_permissiondenied,
  m_messagewillbe,
  m_messageswillbe,
  m_nomessagefound,     // mbread.cpp
  m_erasemessage,
  m_messageerased,
  m_messageiserased,
  m_noboxfound,         // mbdir.cpp
  m_dirofusers,
  m_dirofbulletins,
  m_boardlifemails,
  m_directoryof,
  m_list_nr,
  m_list_call,
  m_list_board,
  m_list_date,
  m_list_time,
  m_list_lines,
  m_list_bytes,
  m_list_bid,
  m_list_life,
  m_list_forw,
  m_list_subject,
  m_lastmessage,
  m_nounreaded,
  m_forcallnomessage,
  m_dirofusermails,
  m_dirafter,
  m_searchfor,
  m_nomessagesfound,
  m_dirpath,
  m_checktitle,       // mbcheck.c
  m_checkentries,
  m_checknoaccess,
  m_logoutput,
  m_noentryfound,
  m_entriesfound,
  m_oneentryfound,
  m_actual,
  m_noactual,
  m_servus,
  m_helplines,
  m_lastlogin,
  m_firstlogin,
  m_inputmybbs,
  m_maintenance,      // mbmain.c
  m_userbusynologin,
  m_conversto,
  m_conversend,
  m_userbusy,
  m_syntaxconvers,
  m_quotaexceed,
  m_nobulletinmore,
  m_cmdinvalid,
  m_possiblecommands,
  m_syntaxmybbs,
  m_syntaxname,
  m_syntaxsend,
  m_noreplypossible,
  m_dirunknown,
  m_nofwdmycall,
  m_date_invalid,
  m_syntaxwall,
  m_mainmenu,
  m_mybbsset,   // mbalter.c
  m_mybbsforward,
  m_neverlogin,
  m_a_headline,
  m_a_mybbs,
  m_a_reject,
  m_a_prompt,
  m_a_firstcmd,
  m_a_name,
  m_a_speech,
  m_a_lines,
  m_a_helplevel,
  m_a_linefeed,
  m_a_idir,
  m_a_udir,
  m_a_ilist,
  m_a_ulist,
  m_a_iread,
  m_a_uread,
  m_a_check,
  m_nohelp,
  m_a_name2,
  m_a_lastdirnew,
  m_a_lastquit,
  m_a_lastlogin,
  m_a_loginmails,
  m_isunknown,
  m_optionsfor,
  m_optionsset,
  m_alterunknown,
  m_dispmybbs,
  m_inputaddress,
  m_adrinvalid,         // mbalter.cpp
  m_cmdtoolong,
  m_commandquit,
  m_cmdstored,
  m_prompttoolong,
  m_promptstored,
  m_pwdtoolong,
  m_pwderased,
  m_pwdlength,
  m_helpvalues,
  m_helpstored,
  m_lfvalues,
  m_nolinefeeds,
  m_onelinefeed,
  m_linefeeds,
  m_nolines,
  m_linesset,
  m_linesvalues,
  m_default,
  m_defaultquery,
  m_defaultmessage,
  m_nametoolong,
  m_nameset,
  m_toomanyreject,
  m_rejectedboards,
  m_languageok,
  m_possiblespeech,
  m_userstateset,
  m_quotaset,
  m_quotaoutput,
  m_maxquota,
  m_yesnoquestion,      // mbinout.cpp
  m_aborted,
  m_helpkeywords,
  m_helpnotfound,
  m_boardpurge,
  m_purgeresult,
  m_tr_notpossible,     // mbread.cpp
  m_msg_processed,      // mbread.cpp
  m_msges_processed,    // mbread.cpp
  m_notallowed,         // mbread.cpp
  m_notavailable,
  m_http_not,           // mbmain.cpp
  m_no_pw,              // mbmain.cpp
  m_a_no_pw,            // mbalter.cpp
  m_too_short,          // mbutil.cpp
  m_filenotfound,       // mbbsplit.cpp, mbfileio.cpp
  m_filemissing,        // mbfileio.cpp
  m_filenotopen,        // mbfileio.cpp
  m_fileexists,         // mbfileio.cpp
  m_filealexists,       // mbfilesv.cpp
  m_filewaiting,        // mbfileio.cpp
  m_filenotstored,      // mbfileio.cpp
  m_filenotrm,          // mbfileio.cpp
  m_filewriteerror,     // mbfileio.cpp
  m_filestored,         // mbfileio.cpp
  m_filenobytes,        // mbfileio.cpp
  m_filecrcerror,       // mbfileio.cpp
  m_fs_welcome,         // mbfilesv.cpp
  m_fs_unknown,         // mbfilesv.cpp
  m_fs_end,             // mbfilesv.cpp
  m_fs_directories,     // mbfilesv.cpp
  m_fwd_toomanydest,
  m_fwd_toomanycalls,
  m_unknownopt,
  m_reserve,

  NUM_MESSAGES,         // needs a dummy line in messages.*
  m_helpext=10000
} MSG_TYP;
